import { Web3Auth } from "@web3auth/web3auth";
import { TorusWalletConnectorPlugin } from "@web3auth/torus-wallet-connector-plugin";
import { SafeEventEmitterProvider, UserInfo } from "@web3auth/base";
import { ethers } from "ethers";
declare let _web3auth: Web3Auth | null;
declare let _provider: ethers.providers.JsonRpcFetchFunc | null;
declare let _signer: ethers.providers.JsonRpcSigner | null;
declare let _infos: Partial<UserInfo> | null;
declare let _error: string | null;
declare let _torusPlugin: TorusWalletConnectorPlugin | null;
export default function useWebThreeAuth(): {
    web3auth: typeof _web3auth;
    provider: typeof _provider;
    signer: typeof _signer;
    pending: boolean;
    infos: typeof _infos;
    torusPlugin: typeof _torusPlugin;
    error: typeof _error;
    connect: () => Promise<SafeEventEmitterProvider | null | undefined>;
};
export {};
